Hooks:PostHook(HUDAssaultCorner, "init", "hudassault_lddg", function(self, ...)
local point_of_no_return_text = self._noreturn_bg_box:child( "point_of_no_return_text" )
	local point_of_no_return_timer = self._noreturn_bg_box:child( "point_of_no_return_timer" )
	local assault_panel = self._hud_panel:child( "assault_panel" )
	local casing_panel = self._hud_panel:child("casing_panel")
	local no_return_panel = self._hud_panel:child("point_of_no_return_panel")
	local casing_icon = casing_panel:child( "icon_casingbox" )
	local noreturn_icon = no_return_panel:child( "icon_noreturnbox" )
	local assault_icon = assault_panel:child( "icon_assaultbox" )
	local scale = LDDG:GetSetting("HudScale")

	assault_panel:show()
	assault_panel:set_alpha(0)
	casing_panel:show()
	casing_panel:set_alpha(0)	
	no_return_panel:show()
	no_return_panel:set_alpha(0)
	assault_panel:text({
		name = "text",
		layer = 2,	
		color = LDDG:GetColor("AssaultColor"),	
		align = "right",
		vertical = "center",		
		font_size = scale * 28, 
		h = scale * 32,
		font = "fonts/font_large_mf",
	})	
	casing_panel:text({
		name = "text",
		layer = 2,		
		align = "right",
		color = LDDG:GetColor("CasingColor"),
		vertical = "center",		
		font_size = scale * 28, 
		h = scale * 32,
		font = "fonts/font_large_mf",
	})
	self._vip_bg_box:child("bg"):hide()
	self._vip_bg_box:child("vip_icon"):hide()
	self._hostages_bg_box:child("bg"):hide()
   	self._bg_box:child("bg"):hide()
   	self._casing_bg_box:child("bg"):hide()
	self._noreturn_bg_box:child("bg"):hide()

   	assault_icon:set_blend_mode("normal")
   	casing_icon:set_blend_mode("normal")
   	noreturn_icon:set_blend_mode("normal")
   	point_of_no_return_text:set_blend_mode("normal")
   	point_of_no_return_timer:set_blend_mode("normal")
   	self._hostages_bg_box:child("num_hostages"):set_blend_mode("normal")	
   	self:UpdateLDDG()

end)
function HUDAssaultCorner:UpdateLDDG(text_list)
	local scale = LDDG:GetSetting("HudScale")
	local font_size = 24 * scale
	local assault_panel = self._hud_panel:child( "assault_panel" )
	local casing_panel = self._hud_panel:child("casing_panel")
	local hostages_panel = self._hud_panel:child("hostages_panel")
	local point_of_no_return_panel = self._hud_panel:child("point_of_no_return_panel")
	local point_of_no_return_text = self._noreturn_bg_box:child( "point_of_no_return_text" )
	local point_of_no_return_timer = self._noreturn_bg_box:child( "point_of_no_return_timer" )	
	local icon_assaultbox = assault_panel:child("icon_assaultbox")
	local icon_casingbox = casing_panel:child("icon_casingbox")	
	local icon_noreturnbox = point_of_no_return_panel:child("icon_noreturnbox")	
	local hostages_icon = hostages_panel:child("hostages_icon")
	assault_panel:set_size(500 * scale, 40 * scale)
	assault_panel:set_righttop(self._hud_panel:w(), 0)	
	casing_panel:set_size(500 * scale, 40 * scale)
	casing_panel:set_righttop(self._hud_panel:w(), 0)	
	point_of_no_return_panel:set_size(500 * scale, 40 * scale)
	point_of_no_return_panel:set_righttop(self._hud_panel:w(), 0)
	hostages_panel:set_size(500 * scale, 40 * scale)
	hostages_panel:set_righttop(self._hud_panel:w(), 0)
	self._hostages_bg_box:set_h(38 * scale)
	local _,_,w,h = assault_panel:child("text"):text_rect()	
   	assault_panel:child("text"):configure({
   		color = LDDG:GetColor("AssaultColor"),
   		font_size = font_size,
   		w = w,
   		h = h,
   	})    	
	icon_assaultbox:configure({
   		color = LDDG:GetColor("AssaultColor"),
		w = 24 * scale,
		h = 24 * scale,
   	})  
   	icon_assaultbox:set_right(assault_panel:w())	
   	assault_panel:child("text"):set_right(icon_assaultbox:left() - 4)
   	local _,_,w,h = casing_panel:child("text"):text_rect()	
   	casing_panel:child("text"):configure({
   		color = LDDG:GetColor("CasingColor"),
   		font_size = font_size,
   		w = w,
   		h = h,
   	})   	
	icon_casingbox:configure({
   		color = LDDG:GetColor("CasingColor"),
		w = 24 * scale,
		h = 24 * scale,
   	})
   	icon_casingbox:set_right(casing_panel:w())	
   	casing_panel:child("text"):set_right(icon_casingbox:left() - 4)
   	hostages_icon:configure({
   		color = LDDG:GetColor("HostageColor"),
		w = 24 * scale,
		h = 24 * scale,
   	})
   	hostages_icon:set_right(hostages_panel:w())	
   	self._hostages_bg_box:set_right(hostages_icon:left())
	icon_noreturnbox:configure({
   		color = LDDG:GetColor("EscapeColor"),
		w = 24 * scale,
		h = 24 * scale,
   	})
   	icon_noreturnbox:set_right(point_of_no_return_panel:w())
 	self._noreturn_bg_box:set_size(242 * scale, font_size)
 	self._noreturn_bg_box:set_right(icon_noreturnbox:left() - 3)
 	self._noreturn_bg_box:set_center_y(icon_noreturnbox:center_y())
   	point_of_no_return_text:configure({
   		color = LDDG:GetColor("EscapeColor"),
		font_size = font_size,
		h = font_size,
		y = 0,
   	})  	   
   	point_of_no_return_timer:configure({
   		color = LDDG:GetColor("EscapeColor"),
		font_size = font_size,
		h = font_size,
		y = 0,
   	})  	
	point_of_no_return_timer:set_size(46 * scale, self._noreturn_bg_box:h())
	point_of_no_return_timer:set_right(self._noreturn_bg_box:w())
	point_of_no_return_text:set_right(math.round(point_of_no_return_timer:left()))

   	self._hostages_bg_box:child("num_hostages"):configure({
   		color = LDDG:GetColor("HostageColor"),
		font_size = font_size,
		h = font_size,
   	})
 	self._hostages_bg_box:child("num_hostages"):set_center_y(hostages_icon:center_y())

    self._hud_panel:child("point_of_no_return_panel"):child("icon_noreturnbox"):set_color(LDDG:GetColor("EscapeColor"))
    self:_set_hostage_offseted(self._is_offseted)
end

function HUDAssaultCorner:_start_assault(s)
	text_list = text_list or ""
	local assault_panel = self._hud_panel:child("assault_panel")
	self:set_text("assault", s)
	self:hide_casing()
	self._assault = true
	assault_panel:animate(callback(nil, _G, "set_alpha"), 1)
	self._bg_box:stop()
	assault_panel:animate(callback(self, self, "animate_assault_in_progress"))
	self._bg_box:animate(callback(nil, _G, "hudbox_animate_open_left"), 0.75, 242, nil, Color(), icon_assaultbox)
end
function HUDAssaultCorner:animate_assault_in_progress(o)
	while self._assault do
		set_alpha(o, 0.6)
		set_alpha(o, 1)
	end
	set_alpha(o, 0)
end
function HUDAssaultCorner:set_buff_enabled(buff_name, enabled)
	self._hud_panel:child("buffs_panel"):set_visible(enabled)
end
function HUDAssaultCorner:_end_assault()
	if not self._assault then
		self._start_assault_after_hostage_offset = nil
		return
	end
	self:_set_feedback_color(nil)
	self._assault = false
	self._remove_hostage_offset = true
	self._start_assault_after_hostage_offset = nil
	local icon_assaultbox = self._hud_panel:child("assault_panel"):child("icon_assaultbox")
	icon_assaultbox:stop()	
	local function close_done()
		icon_assaultbox:stop()
		icon_assaultbox:animate(callback(self, self, "_hide_icon_assaultbox"))		
		self:sync_set_assault_mode("normal")
	end
	self._bg_box:stop()
	self._hud_panel:child("assault_panel"):animate(callback(nil, _G, "set_alpha"), 0)	
	self._bg_box:animate(callback(nil, _G, "HUDBGBox_animate_close_left"), close_done)
end
function HUDAssaultCorner:_hide_icon_assaultbox(icon_assaultbox)
	local TOTAL_T = 1
	local t = TOTAL_T
	while t > 0 do
		local dt = coroutine.yield()
		t = t - dt
		local alpha = math.round(math.abs((math.cos(t * 360 * 2))))
		icon_assaultbox:set_alpha(alpha)
		if self._remove_hostage_offset and t < 0.03 then
			self:_set_hostage_offseted(false)
		end
	end
	if self._remove_hostage_offset then
		self:_set_hostage_offseted(false)
	end
	if not self._casing then
		self:_show_hostages()
	end
end
function HUDAssaultCorner:set_control_info(data)
	self._hostages_bg_box:child("num_hostages"):set_text(data.nr_hostages)
end
function HUDAssaultCorner:set_text(typ, s, add)
	local panel = self._hud_panel:child(typ .. "_panel")
	local text = panel:child("text")
	text:set_text(s)
	local _,_,w,h = text:text_rect()
	text:set_size(w,h)
	text:set_right(panel:child("icon_" .. typ .. "box"):left() - 4)
end
function HUDAssaultCorner:sync_set_assault_mode(mode)
	if self._assault_mode == mode then
		return
	end
	self._assault_mode = mode
	self._current_assault_color = color
	self:set_text("assault", self:_get_assault_strings())	
	local assault_panel = self._hud_panel:child("assault_panel")
	local icon_assaultbox = assault_panel:child("icon_assaultbox")
	local image = mode == "phalanx" and "guis/textures/pd2/hud_icon_padlockbox" or "guis/textures/pd2/hud_icon_assaultbox"
	icon_assaultbox:set_image(image)
end
function HUDAssaultCorner:_get_assault_strings()		
	local difficulty = ""
	for i = 1, managers.job:current_difficulty_stars() do
		difficulty = difficulty .. managers.localization:get_default_macro("BTN_SKULL")
	end		
	return (managers.localization:to_upper_text(self._assault_mode == "normal" and "hud_assault_assault" or "hud_assault_vip") .. " " .. difficulty)
end
function HUDAssaultCorner:_set_hostage_offseted(is_offseted)
	local hostage_panel = self._hud_panel:child("hostages_panel")
	self._remove_hostage_offset = nil
	hostage_panel:animate(callback(self, self, "_offset_hostage"), is_offseted)
	if self._start_assault_after_hostage_offset then
		self._start_assault_after_hostage_offset = nil
		self:start_assault_callback()
	end	
end
function HUDAssaultCorner:_offset_hostage(o, is_offseted)
	self._is_offseted = is_offseted 
	local t = 0
	local from = o:y()
	local target = is_offseted and self._hud_panel:child( "assault_panel" ):bottom() or 0
	while t < 0.5 do
		t = t + coroutine.yield()
		local n = math.sin( t * 200 ) 
		o:set_top(math.lerp(from, target, n))
		if t > 0.3 then
			if self._start_assault_after_hostage_offset then
				self._start_assault_after_hostage_offset = nil
				self:start_assault_callback()
			end			
		end
	end
	o:set_top(target)
end
function HUDAssaultCorner:show_casing(mode)
	local delay_time = self._assault and 1.2 or 0
	self:_end_assault()
	local casing_panel = self._hud_panel:child("casing_panel")
	local msg = mode == "civilian" and "hud_casing_mode_ticker_clean" or "hud_casing_mode_ticker"
	self:set_text("casing", managers.localization:to_upper_text(msg))
	self:_hide_hostages()
	casing_panel:animate(callback(self, self, "_animate_show_casing"), delay_time)
	self._casing = true
end
function HUDAssaultCorner:hide_casing()
	local icon_casingbox = self._hud_panel:child("casing_panel"):child("icon_casingbox")
	icon_casingbox:stop()
	local function close_done()
		self._hud_panel:child("casing_panel"):animate(callback(nil, _G, "set_alpha"), 0)
		self._hud_panel:child("casing_panel"):set_alpha(0)
		local icon_casingbox = self._hud_panel:child("casing_panel"):child("icon_casingbox")
		icon_casingbox:stop()
		icon_casingbox:animate(callback(self, self, "_hide_icon_assaultbox"))		
	end
	self._casing_bg_box:stop()
	self._casing_bg_box:animate(callback(nil, _G, "HUDBGBox_animate_close_left"), close_done)
	self._casing = false
end
function HUDAssaultCorner:_animate_show_casing( casing_panel, delay_time )
	local icon_casingbox = casing_panel:child( "icon_casingbox" )	
	set_alpha(casing_panel, 1)
	self._casing_bg_box:stop()		
	self._casing_bg_box:animate( callback( nil, _G, "hudbox_animate_open_left" ), 0.85, 242, nil, Color(), icon_casingbox )
end
function HUDAssaultCorner:_hide_hostages()
	self._hud_panel:child( "hostages_panel" ):animate(callback(nil, _G, "set_alpha"), 0)
end
function HUDAssaultCorner:_show_hostages()
	if not self._point_of_no_return then
		self._hud_panel:child( "hostages_panel" ):animate(callback(nil, _G, "set_alpha"), 1)
	end
end
function HUDAssaultCorner:_animate_show_noreturn(point_of_no_return_panel, delay_time)
	local icon_noreturnbox = point_of_no_return_panel:child("icon_noreturnbox")
	set_alpha(point_of_no_return_panel, 1)
end

function HUDAssaultCorner:flash_point_of_no_return_timer( beep )
	local scale = LDDG:GetSetting("HudScale")
	local flash_timer = function (o)
		local t = 0
		while t < 0.5 do
			t = t + coroutine.yield()
			local n = 1 - math.sin( t * 180 )
            o:set_font_size( math.lerp( 24 * scale, (24 * scale) * 1.25, n) )
		end
  	end
  	local point_of_no_return_timer = self._noreturn_bg_box:child( "point_of_no_return_timer" )

	point_of_no_return_timer:animate( flash_timer )
end



