Hooks:PostHook(HUDHint, "init", "hudhint_lddg", function(self, ...)
	local clip_panel = self._hint_panel:child("clip_panel")
	clip_panel:child("bg"):hide()
	clip_panel:show()
	clip_panel:set_alpha(0)
	clip_panel:child("hint_text"):set_font(Idstring("fonts/font_large_mf"))
	self._hint_panel:child("marker"):set_h(0)
	self:UpdateLDDG()
end)
function HUDHint:UpdateLDDG()
	local scale = LDDG:GetSetting("HudScale")
	local clip_panel = self._hint_panel:child("clip_panel")
	local hint_text = clip_panel:child("hint_text")
	hint_text:configure({
		color = LDDG:GetColor("HintColor"),
		font_size = 24 * scale, 
		h = 24 * scale, 
	})
	local offset = 32
	local _, _, w, h = hint_text:text_rect()	
	local target_w = w + offset
	hint_text:set_w(target_w)
	clip_panel:set_size(target_w, clip_panel:child("hint_text"):h())
	self._hint_panel:set_h(24 * scale)
	self._hint_panel:set_y(48 * scale)
	clip_panel:set_center_x(self._hint_panel:center_x())
end
function HUDHint:_animate_show(hint_panel, done_cb, seconds, text)
	local clip_panel = hint_panel:child("clip_panel")
	local hint_text = clip_panel:child("hint_text")
	hint_panel:set_visible(true)
	hint_panel:set_alpha(1)
	hint_text:set_text(text)
	local offset = 32
	local _, _, w, h = hint_text:text_rect()	
	local target_w = w + offset
	hint_text:set_w(target_w)
	clip_panel:set_w(target_w)
	clip_panel:set_center_x(self._hint_panel:center_x())
	set_alpha(clip_panel, 1)
	wait(3)
	set_alpha(clip_panel, 0)
	self._stop = false
	hint_panel:set_visible(false)
	done_cb()
end