function HUDManager:teampanels_height()
    return 148 * LDDG:GetSetting("HudScale")
end
function HUDManager:_create_teammates_panel(hud)
    hud = hud or managers.hud:script(PlayerBase.PLAYER_INFO_HUD_PD2)
    self._hud.teammate_panels_data = self._hud.teammate_panels_data or {}
    self._teammate_panels = {}
    if hud.panel:child("teammates_panel") then
        hud.panel:remove(hud.panel:child("teammates_panel"))
    end
    local h = self:teampanels_height()
    local teammates_panel = hud.panel:panel({
        name = "teammates_panel",
        halign = "grow",
        valign = "bottom"
    })
    local teammate_w = 204 * LDDG:GetSetting("HudScale")
    local player_gap = 240
    local small_gap = (teammates_panel:w() - player_gap - teammate_w * 4) / 3
    for i = 1, HUDManager.PLAYER_PANEL do
        local is_player = i == HUDManager.PLAYER_PANEL
        self._hud.teammate_panels_data[i] = {
            taken = false,
            special_equipments = {}
        }
        local pw = teammate_w + (is_player and 32 or 64)
        local teammate = HUDTeammate:new(i, teammates_panel, is_player, pw)
        local x = math.floor(((pw - (is_player and 42 or 0)) + small_gap) * (i - 1) + (i == HUDManager.PLAYER_PANEL and player_gap or 0))
        teammate._panel:set_x(math.floor(x))
        table.insert(self._teammate_panels, teammate)
        if is_player then
            teammate:add_panel()
        end
    end
end
function HUDManager:hide_player_gear(panel_id)
    if self._teammate_panels[panel_id] and self._teammate_panels[panel_id]:panel() and self._teammate_panels[panel_id]:panel():child("player") then
        local player_panel = self._teammate_panels[panel_id]:panel():child("player")
        player_panel:child("ammo_text"):hide()
        player_panel:child("primary_panel"):hide()
        player_panel:child("secondary_panel"):hide()
        player_panel:child("deployable_equipment_panel"):hide()
        player_panel:child("cable_ties_panel"):hide()
        player_panel:child("grenades_panel"):hide()
    end
end
function HUDManager:show_player_gear(panel_id)
    if self._teammate_panels[panel_id] and self._teammate_panels[panel_id]:panel() and self._teammate_panels[panel_id]:panel():child("player") then
        local player_panel = self._teammate_panels[panel_id]:panel():child("player")
        player_panel:child("ammo_text"):show()
        player_panel:child("primary_panel"):show()
        player_panel:child("secondary_panel"):show()
        player_panel:child("deployable_equipment_panel"):show()
        player_panel:child("cable_ties_panel"):show()
        player_panel:child("grenades_panel"):show()
    end
end
function HUDManager:align_teammate_panels()
    local teammate_w = 204 * LDDG:GetSetting("HudScale")
    local player_gap = 240    
    local h = self:teampanels_height()    
    local small_gap = (managers.hud:script(PlayerBase.PLAYER_INFO_HUD_PD2).panel:child("teammates_panel"):w() - player_gap - teammate_w * 4) / 3
    for i = 1, HUDManager.PLAYER_PANEL do 
        local is_player = i == HUDManager.PLAYER_PANEL
        if self._teammate_panels[i] then       
            local pw = teammate_w + (is_player and 32 or 64)
            local x = math.floor(((pw - (is_player and 42 or 0)) + small_gap) * (i - 1) + (i == HUDManager.PLAYER_PANEL and player_gap or 0))
            self._teammate_panels[i]._panel:set_size(pw, h) 
            self._teammate_panels[i]._player_panel:set_size(pw, h) 
            self._teammate_panels[i]._panel:set_x(x)    
            self._teammate_panels[i]._panel:set_bottom(self._teammate_panels[i]._panel:parent():h())  
        end     
    end    
end
function HUDManager:UpdateLDDG()
    if self:alive(Idstring("guis/mask_off_hud")) then
         self:script(Idstring("guis/mask_off_hud")):UpdateLDDG()
    end
end
Hooks:PostHook(HUDManager, "show", "hudmanager_show", function(self, name)    
    if name == Idstring("guis/mask_off_hud") then
        if self:alive(name) then
            local script = self:script(name)
            script.UpdateLDDG = function(this)
                local scale = LDDG:GetSetting("HudScale")
                this.mask_on_text:set_font(Idstring("fonts/font_large_mf"))
                this.mask_on_text:set_font_size(24 * scale)
                self:make_fine_text(this.mask_on_text)
                this.mask_on_text:set_y(24 * scale)
                this.mask_on_text:set_center_x(this.panel:center_x())
            end
            script:UpdateLDDG()
        end
    end
end)
 
