Hooks:PostHook(HUDPresenter, "init", "hudpresenter_lddg", function(self, ...)	
	self._hud_panel:child("present_panel"):set_alpha(0)
	self:UpdateLDDG()
end)
function HUDPresenter:UpdateLDDG()
 	local scale = LDDG:GetSetting("HudScale")
 	local color = LDDG:GetColor("PresenterColor")
 	local title = self._bg_box:child("title")	
 	local text = self._bg_box:child("text")	
 	self._hud_panel:child("present_panel"):show()
 	self._bg_box:child("bg"):hide()	
	title:configure({
		visible = true,
		color = color,
		font = "fonts/font_large_mf",
		font_size = 24 * scale,
		h = 24 * scale,
	})
	text:configure({
		visible = true,
		color = color,
		font = "fonts/font_large_mf",
		font_size = 20 * scale,
		h = 20 * scale,
	})	
	local _, _, w, _ = title:text_rect()
	title:set_w(w)
	local _, _, w2, _ = text:text_rect()
	text:set_w(w2)	
 	local w = math.max(w, w2) + 16
	local h = 68
	local x = math.round(self._hud_panel:w() / 2 - w / 2)
	local y = 72 * scale
	self._bg_box:set_shape(x, y, w, h * scale)
	title:set_bottom(math.floor(self._bg_box:h() / 2) + 2)
	text:set_top(math.ceil(self._bg_box:h() / 2) - 2)
end
function HUDPresenter:_animate_present_information(present_panel, params)	
	set_alpha(present_panel, 1)
	wait(3)
	set_alpha(present_panel, 0)
	self:_present_done()
end
function HUDPresenter:_present_information(params)
	local present_panel = self._hud_panel:child("present_panel")
	local title = self._bg_box:child("title")
	local text = self._bg_box:child("text")
	title:set_text(utf8.to_upper(params.title or "ERROR"))
	text:set_text(utf8.to_upper(params.text))
	local _, _, w, _ = title:text_rect()
	title:set_w(w)
	local _, _, w2, _ = text:text_rect()
	text:set_w(w2)
	local tw = math.max(w, w2)
	self._bg_box:set_w(tw + 16)
	self._bg_box:set_left(math.round(self._bg_box:parent():w() / 2 - self._bg_box:w() / 2))
	if params.icon then
	end
	if params.event then
		managers.hud._sound_source:post_event(params.event)
	end
	present_panel:animate(callback(self, self, "_animate_present_information"), {
		done_cb = callback(self, self, "_present_done"),
		seconds = params.time or 4,
		use_icon = params.icon
	})
	self._presenting = true
end
function HUDPresenter:_animate_hide_text(title, text)
end

