Hooks:PostHook(HUDTemp, "init", "hudtemp_lddg", function(self, ...)
	self:UpdateLDDG()
end)
function HUDTemp:_animate_hide_bag_panel(bag_panel)
	local bag_text = self._bg_box:child("bag_text")
	bag_panel:set_x(self._temp_panel:w() - bag_panel:w())
	bag_panel:set_y(self:_bag_panel_bottom() - bag_panel:h())
	set_alpha(bag_panel, 0)	
	bag_text:set_visible(false)
end
function HUDTemp:UpdateLDDG()	
	local scale = LDDG:GetSetting("HudScale")
	local bag_panel = self._temp_panel:child("bag_panel")
	self._bg_box:child("bg"):hide()
	bag_panel:configure({
		w = 204 * scale, 
		h = 28 * scale,
		visible = true,
		alpha = 0,
	}) 
	self._bg_box:set_w(bag_panel:w(), bag_panel:h())
	bag_panel:set_world_bottom(managers.hud._teammate_panels[HUDManager.PLAYER_PANEL]._panel:world_top())
	bag_panel:set_world_left(managers.hud._teammate_panels[HUDManager.PLAYER_PANEL]._panel:world_left())
	self._bg_box:child("bag_text"):configure({
		visible = true,
		font_size = 20 * scale,
		color = LDDG:GetColor("CarryBagColor"),
		blend_mode = "normal",
	})
	managers.hud:make_fine_text(self._bg_box:child("bag_text"))
	self._bg_box:child("bag_text"):set_right(bag_panel:w())
end
function HUDTemp:_animate_show_bag_panel(bag_panel)
	local bag_text = self._bg_box:child("bag_text")
	bag_text:set_visible(true)
	bag_panel:set_y(self:_bag_panel_bottom() - bag_panel:h())
	bag_panel:set_x(self._temp_panel:w() - bag_panel:w())	

	set_alpha(bag_panel, 1)	
	while bag_text:visible() do
		set_alpha(bag_panel, 0.6)
		set_alpha(bag_panel, 1)
	end
end 


function HUDTemp:show_carry_bag(carry_id, value)
	local bag_panel = self._temp_panel:child("bag_panel")
	local carry_data = tweak_data.carry[carry_id]
	local type_text = carry_data.name_id and managers.localization:text(carry_data.name_id)
	bag_panel:set_x(self._temp_panel:parent():w() / 2)
	bag_panel:set_visible(true)
	self._bg_box:child("bag_text"):hide()
	local carrying_text = managers.localization:text("hud_carrying")
	self._bg_box:child("bag_text"):set_text(utf8.to_upper(carrying_text .. " " .. type_text))
	self._bg_box:set_w(bag_panel:w(), bag_panel:h())
	self._bg_box:set_position(0, 0)
	self:UpdateLDDG()
	bag_panel:stop()
	bag_panel:animate(callback(self, self, "_animate_show_bag_panel"))
end 